## Xalan-C++ API Documentation

### The Xalan C++ XSLT Processor Version 1.10

Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members

# XercesParserLiaison Class Reference

`#include <XercesParserLiaison.hpp>`

Inheritance diagram for XercesParserLiaison:

[legend]
Collaboration diagram for XercesParserLiaison:

[legend]
List of all members.

## Public Types

- typedef XERCES_CPP_NAMESPACE_QUALIFIER
  SAXParser SAXParserType
- typedef XalanMap<const XalanDocument*,
  DocumentEntry> DocumentMapType
- typedef XERCES_CPP_NAMESPACE_QUALIFIER
  DOMParser DOMParserType

## Public Methods

- XercesParserLiaison (XercesDOMSupport &theSupport, MemoryManagerType &theManager XALAN_DEFAULT_MEMMGR)
    Construct a XercesParserLiaison instance. More...
- XercesParserLiaison (MemoryManagerType &theManager XALAN_DEFAULT_MEMMGR)
    Construct a XercesParserLiaison instance. More...
- virtual ~XercesParserLiaison ()
- MemoryManagerType& getMemoryManager ()
- virtual void reset ()
- virtual ExecutionContext* getExecutionContext () const
- virtual void setExecutionContext (ExecutionContext &theContext)
- virtual XalanDocument* parseXMLStream (const InputSourceType &reader, const XalanDOMString &identifier=XalanDOMString(XalanMemMgrs::getDummyMemMgr()))
    Parse the text pointed at by the reader as XML, and return a DOM Document interface. More...
- virtual void parseXMLStream (const InputSourceType &urlInputSource, DocumentHandlerType &handler, const XalanDOMString &identifier=XalanDOMString(XalanMemMgrs::getDummyMemMgr()))
    Parse the text pointed at by the reader as XML. More...
- virtual void destroyDocument (XalanDocument *theDocument)
    Destroy the supplied XalanDocument instance. More...
- virtual int getIndent () const
    Get the amount to indent when indent-result="yes". More...
- virtual void setIndent (int i)
    Set the amount to indent when indent-result="yes". More...
- virtual bool getUseValidation () const
    Get whether or not validation will be performed. More...
- virtual void setUseValidation (bool b)
    If set to true, validation will be performed. More...
- virtual const XalanDOMString& getParserDescription (XalanDOMString &theResult) const
    Return a string suitable for telling the user what parser is being used. More...
- virtual EntityResolverType* getEntityResolver () const
    This method returns the installed entity resolver. More...
- virtual void setEntityResolver (EntityResolverType *resolver)
    This method installs the user specified entity resolver on the parser. More...
- virtual DOMDocument_Type* createDOMFactory ()
    Create an instance of the Xerces default document that is suitable as a raw document. More...
- virtual void destroyDocument (DOMDocument_Type *theDocument)
    Destroy an instance created by a call to createDOMFactory(). More...
- virtual bool getIncludeIgnorableWhitespace () const
    Get the 'include ignorable whitespace' flag. More...
- virtual void setIncludeIgnorableWhitespace (bool include)
    Set the 'include ignorable whitespace' flag. More...
- virtual ErrorHandlerType* getErrorHandler () const
    This method returns the installed error handler. More...
- virtual void setErrorHandler (ErrorHandlerType *handler)
    This method installs the user specified error handler on the parser. More...
- virtual bool getDoNamespaces () const
    This method returns the state of the parser's namespace handling capability. More...
- virtual void setDoNamespaces (bool newState)
    This method allows users to enable or disable the parser's namespace processing. More...
- virtual bool getExitOnFirstFatalError () const
    This method returns the state of the parser's exit-on-First-Fatal-Error flag. More...
- virtual void setExitOnFirstFatalError (bool newState)
    This method allows users to set the parser's behaviour when it encounters the first fatal error. More...
- virtual const XalanDOMChar* getExternalSchemaLocation () const
    This method returns the location for an external schema document for parsing. More...
- virtual void setExternalSchemaLocation (const XalanDOMChar *location)
    This method sets the location for an external schema document for parsing. More...
- virtual const XalanDOMChar* getExternalNoNamespaceSchemaLocation () const
    This method returns the location for an external schema document for parsing. More...
- virtual void setExternalNoNamespaceSchemaLocation (const XalanDOMChar *location)
    This method sets the location for an external schema document for parsing. More...
- XalanDocument* createDocument (const DOMDocument_Type *theXercesDocument)
    Create a XalanDocument proxy for an existing Xerces document. More...
- XalanDocument* createDocument (const DOMDocument_Type *theXercesDocument, bool threadSafe, bool buildWrapper, bool buildMaps=false)
    Create a XalanDocument proxy for an existing Xerces document. More...
- XercesDocumentWrapper* mapDocumentToWrapper (const XalanDocument *theDocument) const
    Map a pointer to a XalanDocument instance to its implementation class pointer. More...
- const DOMDocument_Type* mapToXercesDocument (const XalanDocument *theDocument) const
    Map a pointer to a XalanDocument instance to its corresponding class pointer. More...
- virtual void warning (const SAXParseExceptionType &exception)
- virtual void error (const SAXParseExceptionType &exception)
- virtual void fatalError (const SAXParseExceptionType &exception)
- virtual void resetErrors ()
- bool getBuildBridgeNodes () const
    This API is deprecated. More...
- void setBuildBridgeNodes (bool newState)
    This API is deprecated. More...
- bool getBuildWrapperNodes () const
    This functions returns the state of the liaison's build-wrapper-nodes flag. More...
- void setBuildWrapperNodes (bool newState)
    This functions sets the state of the liaison's build-wrapper-nodes flag. More...
- bool getThreadSafe () const
    This functions returns the state of the liaison's thread-safe flag. More...
- void setThreadSafe (bool newState)
    This functions sets the state of the liaison's thread-safe flag. More...
- bool getBuildMaps () const
    This functions returns the state of the liaison's buildMaps flag. More...
- void setBuildMaps (bool newState)
    This functions sets the state of the liaison's buildMaps flag. More...

## Protected Methods

- XercesDocumentWrapper* doCreateDocument (const DOMDocument_Type *theXercesDocument, bool threadSafe, bool buildWrapper, bool buildMaps, bool isOwned)
    Create a XalanDocument proxy for an existing Xerces document. More...

## Static Protected Methods

- void formatErrorMessage (const SAXParseExceptionType &e, XalanDOMString &theMessage)

## Member Typedef Documentation

typedef XERCES_CPP_NAMESPACE_QUALIFIER DOMParser XercesParserLiaison::DOMParserType

typedef XalanMap< const XalanDocument *, DocumentEntry > XercesParserLiaison::DocumentMapType<const XalanDocument*, DocumentEntry>

typedef XERCES_CPP_NAMESPACE_QUALIFIER SAXParser XercesParserLiaison::SAXParserType

## Constructor & Destructor Documentation

XercesParserLiaison::XercesParserLiaison ( | XercesDOMSupport & theSupport,
| MemoryManagerType &theManager XALAN_DEFAULT_MEMMGR )

  | Construct a XercesParserLiaison instance. Parameters:
  theSupport | instance of DOMSupport object
Deprecated: This constructor is deprecated. Use the next constructor instead.

XercesParserLiaison::XercesParserLiaison ( | MemoryManagerType &theManager XALAN_DEFAULT_MEMMGR )

| Construct a XercesParserLiaison instance.

XercesParserLiaison::~XercesParserLiaison ( | )`[virtual]`

## Member Function Documentation

DOMDocument_Type * XercesParserLiaison::createDOMFactory ( | )`[virtual]`

| Create an instance of the Xerces default document that is suitable as a raw document. The new document instance is owned by this instance and will be destroyed when this instance goes out of scope, or by an explicit call to destroyDocument() Returns: a pointer to the new instance

XalanDocument * XercesParserLiaison::createDocument ( | const DOMDocument_Type * theXercesDocument,
| bool threadSafe,
| bool buildWrapper,
| bool buildMaps = false )

  | Create a XalanDocument proxy for an existing Xerces document. The parser liaison owns the instance, and you must not delete it. The liaison will delete it when reset() is called, or the liaison is destroyed. Parameters:
  theXercesDocument | The Xerces document.
  threadSafe | If true, read access to the tree will be thread-safe (implies buildWrapper == true).
  buildWrapper | If true, the entire wrapper structure is built.
  buildMaps | If true, the map of Xerces to Xalan nodes is always built.
Returns: a pointer to a new XalanDocument-derived instance.

XalanDocument * XercesParserLiaison::createDocument ( | const DOMDocument_Type * theXercesDocument )

  | Create a XalanDocument proxy for an existing Xerces document. The parser liaison owns the instance, and you must not delete it. The liaison will delete it when reset() is called, or the liaison is destroyed. Parameters:
  theXercesDocument | The Xerces document.
Returns: a pointer to a new XalanDocument-derived instance.

void XercesParserLiaison::destroyDocument ( | DOMDocument_Type * theDocument )`[virtual]`

| Destroy an instance created by a call to createDOMFactory(). @theDocument a pointer to the instance to be destroyed

void XercesParserLiaison::destroyDocument ( | XalanDocument * theDocument )`[virtual]`

  | Destroy the supplied XalanDocument instance. It must be an instance that was created by a previous call to parseXMLStream(). Parameters:
  theDocument | The XalanDocument instance to destroy.
Reimplemented from XMLParserLiaison.

XercesDocumentWrapper * XercesParserLiaison::doCreateDocument ( | const DOMDocument_Type * theXercesDocument,
| bool threadSafe,
| bool buildWrapper,
| bool buildMaps,
| bool isOwned )`[protected]`

  | Create a XalanDocument proxy for an existing Xerces document. Parameters:
  theXercesDocument | The Xerces document.
  threadSafe | If true, read access to the tree will be thread-safe (implies buildBridge == true).
  buildWrapper | If true, the entire bridge structure is built.
  buildMaps | If true, the map of Xerces to Xalan nodes is always built.
Returns: a pointer to a new XercesDocumentWrapper instance.

void XercesParserLiaison::error ( | const SAXParseExceptionType & exception )`[virtual]`

void XercesParserLiaison::fatalError ( | const SAXParseExceptionType & exception )`[virtual]`

void XercesParserLiaison::formatErrorMessage ( | const SAXParseExceptionType & e,
| XalanDOMString & theMessage )`[static, protected]`

bool XercesParserLiaison::getBuildBridgeNodes ( | ) const

| This API is deprecated. This functions returns the state of the liaison's build-bridge-nodes flag. Deprecated: The Xerces DOM bridge is deprecated. Returns: true, if the bridge nodes are automatically built, false otherwise.

bool XercesParserLiaison::getBuildMaps ( | ) const

| This functions returns the state of the liaison's buildMaps flag. If true, maps will be created to allow mapping of Xalan<->Xerces mapping in both directions for XercesWrapper classes. Returns: true, if the new documents will be built with Maps

bool XercesParserLiaison::getBuildWrapperNodes ( | ) const

| This functions returns the state of the liaison's build-wrapper-nodes flag. Returns: true, if the wrapper nodes are automatically built, false otherwise.

bool XercesParserLiaison::getDoNamespaces ( | ) const`[virtual]`

| This method returns the state of the parser's namespace handling capability. Returns: true, if the parser is currently configured to understand namespaces, false otherwise. See also: setDoNamespaces

EntityResolverType * XercesParserLiaison::getEntityResolver ( | ) const`[virtual]`

| This method returns the installed entity resolver. Returns: The pointer to the installed entity resolver object. Reimplemented from XMLParserLiaison.

ErrorHandlerType * XercesParserLiaison::getErrorHandler ( | ) const`[virtual]`

| This method returns the installed error handler. Returns: A pointer to the installed error handler object. Reimplemented from XMLParserLiaison.

ExecutionContext * XercesParserLiaison::getExecutionContext ( | ) const`[virtual]`

| Reimplemented from XMLParserLiaison.

bool XercesParserLiaison::getExitOnFirstFatalError ( | ) const`[virtual]`

| This method returns the state of the parser's exit-on-First-Fatal-Error flag. Returns: true, if the parser is currently configured to exit on the first fatal error, false otherwise. See also: setExitOnFirstFatalError

const XalanDOMChar * XercesParserLiaison::getExternalNoNamespaceSchemaLocation ( | ) const`[virtual]`

| This method returns the location for an external schema document for parsing. Returns: A string representing the location of the external schema document

const XalanDOMChar * XercesParserLiaison::getExternalSchemaLocation ( | ) const`[virtual]`

| This method returns the location for an external schema document for parsing. Returns: A string representing the location of the external schema document

bool XercesParserLiaison::getIncludeIgnorableWhitespace ( | ) const`[virtual]`

| Get the 'include ignorable whitespace' flag. This method returns the state of the parser's include ignorable whitespace flag. Returns: 'true' if the include ignorable whitespace flag is set on the parser, 'false' otherwise. See also: setIncludeIgnorableWhitespace

int XercesParserLiaison::getIndent ( | ) const`[virtual]`

| Get the amount to indent when indent-result="yes". Deprecated: Returns: number of characters to indent Reimplemented from XMLParserLiaison.

MemoryManagerType & XercesParserLiaison::getMemoryManager ( | )`[virtual]`

| Reimplemented from XMLParserLiaison.

const XalanDOMString & XercesParserLiaison::getParserDescription ( | XalanDOMString & theResult ) const`[virtual]`

| Return a string suitable for telling the user what parser is being used. Returns: string describing parser Reimplemented from XMLParserLiaison.

bool XercesParserLiaison::getThreadSafe ( | ) const

| This functions returns the state of the liaison's thread-safe flag. If true, documents created will be safe when data is read. By default, documents are _not_ thread-safe. Note -- modifications are _never_ synchronized. Returns: true, if the new documents will be thread safe, false otherwise.

bool XercesParserLiaison::getUseValidation ( | ) const`[virtual]`

| Get whether or not validation will be performed. Validation is off by default. Returns: true to perform validation Reimplemented from XMLParserLiaison.

XercesDocumentWrapper * XercesParserLiaison::mapDocumentToWrapper ( | const XalanDocument * theDocument ) const

  | Map a pointer to a XalanDocument instance to its implementation class pointer. Normally, you should have no reason for doing this. The liaison will return a null pointer if it did not create the instance passed. Parameters:
  theDocument | A pointer to a XalanDocument instance.
Returns: A pointer to the XercesDocumentWrapper instance.

const DOMDocument_Type * XercesParserLiaison::mapToXercesDocument ( | const XalanDocument * theDocument ) const

  | Map a pointer to a XalanDocument instance to its corresponding class pointer. Normally, you should have no reason for doing this. The liaison will return a null pointer if it did not create the instance passed. Parameters:
  theDocument | A pointer to a XalanDocument instance.
Returns: A pointer to the XercesDocumentBridge instance.

void XercesParserLiaison::parseXMLStream ( | const InputSourceType & urlInputSource,
| DocumentHandlerType & handler,
| const XalanDOMString & identifier = XalanDOMString(XalanMemMgrs::getDummyMemMgr()) )`[virtual]`

  | Parse the text pointed at by the reader as XML. It is recommended that you pass in some sort of recognizable name, such as the filename or URI, with which the reader can be recognized if the parse fails. Parameters:
  inputSource | input source that should hold valid XML
  handler | instance of a DocumentHandler
  identifier | used for diagnostic purposes only, some sort of identification for error reporting, default an empty string
Reimplemented from XMLParserLiaison.

XalanDocument * XercesParserLiaison::parseXMLStream ( | const InputSourceType & reader,
| const XalanDOMString & identifier = XalanDOMString(XalanMemMgrs::getDummyMemMgr()) )`[virtual]`

  | Parse the text pointed at by the reader as XML, and return a DOM Document interface. It is recommended that you pass in some sort of recognizable name, such as the filename or URI, with which the reader can be recognized if the parse fails. The liaison owns the XalanDocument instance, and will delete it when when asked (see DestroyDocument()), or when the liaison is reset, or goes out of scope. Parameters:
  reader | stream that should hold valid XML
  identifier | used for diagnostic purposes only, some sort of identification for error reporting, default an empty string
Returns: DOM document created Reimplemented from XMLParserLiaison.

void XercesParserLiaison::reset ( | )`[virtual]`

| Reimplemented from XMLParserLiaison.

void XercesParserLiaison::resetErrors ( | )`[virtual]`

void XercesParserLiaison::setBuildBridgeNodes ( | bool newState )

  | This API is deprecated. This functions sets the state of the liaison's build-bridge-nodes flag. This flag must be set for the document to be thread safe. It can also be set to true to increase performance. If this flag is set to false, then the thread-safe flag will also be set to false. Deprecated: The Xerces DOM bridge is deprecated. Parameters:
  newState | The new state for the flag.

void XercesParserLiaison::setBuildMaps ( | bool newState )

  | This functions sets the state of the liaison's buildMaps flag. When this flag is true, maps will be built providing Xerces<->Xalan mapping in Wrapper classes. Note: The maps created use a large amount of memory. If only Xalan->Xerces node mapping is required, do not set this to true. Parameters:
  newState | The new state for the flag.

void XercesParserLiaison::setBuildWrapperNodes ( | bool newState )

  | This functions sets the state of the liaison's build-wrapper-nodes flag. This flag must be set for the document to be thread safe. It can also be set to true to increase performance. If this flag is set to false, then the thread-safe flag will also be set to false. Parameters:
  newState | The new state for the flag.

void XercesParserLiaison::setDoNamespaces ( | bool newState )`[virtual]`

  | This method allows users to enable or disable the parser's namespace processing. When set to true, parser starts enforcing all the constraints / rules specified by the NameSpace specification. The parser's default state is: false. This flag is ignored by the underlying scanner if the installed validator indicates that namespace constraints should be enforced. Parameters:
  newState | The value specifying whether NameSpace rules should be enforced or not.
See also: getDoNamespaces

void XercesParserLiaison::setEntityResolver ( | EntityResolverType * resolver )`[virtual]`

  | This method installs the user specified entity resolver on the parser. It allows applications to trap and redirect calls to external entities. Parameters:
  handler | A pointer to the entity resolver to be called when the parser comes across references to entities in the XML file.
Reimplemented from XMLParserLiaison.

void XercesParserLiaison::setErrorHandler ( | ErrorHandlerType * handler )`[virtual]`

  | This method installs the user specified error handler on the parser. Parameters:
  handler | A pointer to the error handler to be called when the parser comes across 'error' events as per the SAX specification.
Reimplemented from XMLParserLiaison.

void XercesParserLiaison::setExecutionContext ( | ExecutionContext & theContext )`[virtual]`

| Reimplemented from XMLParserLiaison.

void XercesParserLiaison::setExitOnFirstFatalError ( | bool newState )`[virtual]`

  | This method allows users to set the parser's behaviour when it encounters the first fatal error. If set to true, the parser will exit at the first fatal error. If false, then it will report the error and continue processing. The default value is 'true' and the parser exits on the first fatal error. Parameters:
  newState | The value specifying whether the parser should continue or exit when it encounters the first fatal error.
See also: getExitOnFirstFatalError

void XercesParserLiaison::setExternalNoNamespaceSchemaLocation ( | const XalanDOMChar * location )`[virtual]`

  | This method sets the location for an external schema document for parsing. Parameters:
  location | A string representing the location of the external schema document

void XercesParserLiaison::setExternalSchemaLocation ( | const XalanDOMChar * location )`[virtual]`

  | This method sets the location for an external schema document for parsing. Parameters:
  location | A string representing the location of the external schema document

void XercesParserLiaison::setIncludeIgnorableWhitespace ( | bool include )`[virtual]`

  | Set the 'include ignorable whitespace' flag. This method allows the user to specify whether a validating parser should include ignorable whitespaces as text nodes. It has no effect on non-validating parsers which always include non-markup text. When set to true (also the default), ignorable whitespaces will be added to the DOM tree as text nodes. The method `DOMText::isIgnorableWhitespace` will return true for those text nodes only. When set to false, all ignorable whitespace will be discarded and no text node is added to the DOM tree. Note: applications intended to process the "xml:space" attribute should not set this flag to false. Parameters:
  include | The new state of the include ignorable whitespace flag.
See also: getIncludeIgnorableWhitespace

void XercesParserLiaison::setIndent ( | int i )`[virtual]`

  | Set the amount to indent when indent-result="yes". Deprecated: Parameters:
  i | number of characters to indent
Reimplemented from XMLParserLiaison.

void XercesParserLiaison::setThreadSafe ( | bool newState )

  | This functions sets the state of the liaison's thread-safe flag. This flag must be set for the document to be thread safe. If this flag is set to true, then the build-bridge-nodes flag will also be set to true. Parameters:
  newState | The new state for the flag.

void XercesParserLiaison::setUseValidation ( | bool b )`[virtual]`

  | If set to true, validation will be performed. Validation is off by default. Parameters:
  b | true to perform validation
Reimplemented from XMLParserLiaison.

void XercesParserLiaison::warning ( | const SAXParseExceptionType & exception )`[virtual]`

The documentation for this class was generated from the following file:

- XercesParserLiaison.hpp

Interpreting class diagrams

Doxygen and GraphViz are used to generate this API documentation from the Xalan-C header files.

Xalan-C++ XSLT Processor Version 1.10 Copyright © 1999-2004 The Apache Software Foundation. All Rights Reserved.